var cacheManager = require('cache-manager');
var redisStore = require('./index');

var redisCache = cacheManager.caching({
	store: redisStore,
	host: 'localhost', // default value
	port: 6379, // default value
	db: 0,
	ttl: 600
});

var ttl = 5;

for (var i = 0; i < 10000; i++) {
    redisCache.set('foo', 'bar', ttl, function(err) {
        if (err) {
          throw err;
        }

        redisCache.get('foo', function(err, result) {
            console.log(result);
            // >> 'bar'
            redisCache.del('foo', function(err) {});
        });
    });

    function getUser(id, cb) {
        setTimeout(function () {
            console.log("Returning user from slow database.");
            cb(null, {id: id, name: 'Bob'});
        }, 100);
    }

    var userId = 123;
    var key = 'user_' + userId;

    // Note: ttl is optional in wrap()
    redisCache.wrap(key, function (cb) {
        getUser(userId, cb);
    }, ttl, function (err, user) {
        console.log(user);

        // Second time fetches user from redisCache
        redisCache.wrap(key, function (cb) {
            getUser(userId, cb);
        }, function (err, user) {
            console.log(user);
        });
    });
}